• [LeetCode] Minimum Height Trees 最小高度树


    For a undirected graph with tree characteristics, we can choose any node as the root. The result graph is then a rooted tree. Among all possible rooted trees, those with minimum height are called minimum height trees (MHTs). Given such a graph, write a function to find all the MHTs and return a list of their root labels.

    Format
    The graph contains n nodes which are labeled from 0 to n - 1. You will be given the number n and a list of undirected edges (each edge is a pair of labels).

    You can assume that no duplicate edges will appear in edges. Since all edges are undirected, [0, 1] is the same as [1, 0] and thus will not appear together in edges.

    Example 1:

    Given n = 4edges = [[1, 0], [1, 2], [1, 3]]

            0
            |
            1
           / 
          2   3
    

    return [1]

    Example 2:

    Given n = 6edges = [[0, 3], [1, 3], [2, 3], [4, 3], [5, 4]]

         0  1  2
           | /
            3
            |
            4
            |
            5
    

    return [3, 4]

    Hint:

    1. How many MHTs can a graph have at most?

    Note:

    (1) According to the definition of tree on Wikipedia: “a tree is an undirected graph in which any two vertices are connected by exactly one path. In other words, any connected graph without simple cycles is a tree.”

    (2) The height of a rooted tree is the number of edges on the longest downward path between the root and a leaf.

    Credits:
    Special thanks to @peisi for adding this problem and creating all test cases.

    Update (2015-11-25):
    The function signature had been updated to return List<Integer> instead of integer[]. Please click the reload button above the code editor to reload the newest default code definition.

    这道题虽然是树的题目,但是跟其最接近的题目是Course Schedule 课程清单Course Schedule II 课程清单之二。由于LeetCode中的树的题目主要都是针对于二叉树的,而这道题虽说是树但其实本质是想考察图的知识,这道题刚开始在拿到的时候,我最先想到的解法是遍历的点,以每个点都当做根节点,算出高度,然后找出最小的,但是一时半会又写不出程序来,于是上网看看大家的解法,发现大家推崇的方法是一个类似剥洋葱的方法,就是一层一层的褪去叶节点,最后剩下的一个或两个节点就是我们要求的最小高度树的根节点,这种思路非常的巧妙,而且实现起来也不难,跟之前那到课程清单的题一样,我们需要建立一个图g,是一个二维数组,其中g[i]是一个一维数组,保存了i节点可以到达的所有节点。我们开始将所有只有一个连接边的节点(叶节点)都存入到一个队列queue中,然后我们遍历每一个叶节点,通过图来找到和其相连的节点,并且在其相连节点的集合中将该叶节点删去,如果删完后此节点也也变成一个叶节点了,加入队列中,再下一轮删除。那么我们删到什么时候呢,当节点数小于等于2时候停止,此时剩下的一个或两个节点就是我们要求的最小高度树的根节点啦,参见代码如下:

    C++ 解法一:

    class Solution {
    public:
        vector<int> findMinHeightTrees(int n, vector<pair<int, int> >& edges) {
            if (n == 1) return {0};
            vector<int> res;
            vector<unordered_set<int>> adj(n);
            queue<int> q;
            for (auto edge : edges) {
                adj[edge.first].insert(edge.second);
                adj[edge.second].insert(edge.first);
            }
            for (int i = 0; i < n; ++i) {
                if (adj[i].size() == 1) q.push(i);
            }
            while (n > 2) {
                int size = q.size();
                n -= size;
                for (int i = 0; i < size; ++i) {
                    int t = q.front(); q.pop();
                    for (auto a : adj[t]) {
                        adj[a].erase(t);
                        if (adj[a].size() == 1) q.push(a);
                    }
                }
            }
            while (!q.empty()) {
                res.push_back(q.front()); q.pop();
            }
            return res;
        }
    };

    Java 解法一:

    public class Solution {
        public List<Integer> findMinHeightTrees(int n, int[][] edges) {
            if (n == 1) return Collections.singletonList(0);
            List<Integer> leaves = new ArrayList<>();
            List<Set<Integer>> adj = new ArrayList<>(n);
            for (int i = 0; i < n; ++i) adj.add(new HashSet<>());
            for (int[] edge : edges) {
                adj.get(edge[0]).add(edge[1]);
                adj.get(edge[1]).add(edge[0]);
            }
            for (int i = 0; i < n; ++i) {
                if (adj.get(i).size() == 1) leaves.add(i);
            }
            while (n > 2) {
                n -= leaves.size();
                List<Integer> newLeaves = new ArrayList<>();
                for (int i : leaves) {
                    int t = adj.get(i).iterator().next();
                    adj.get(t).remove(i);
                    if (adj.get(t).size() == 1) newLeaves.add(t);
                }
                leaves = newLeaves;
            }
            return leaves;
        }
    }

    此题还有递归的解法(未完待续...)

    类似题目:

    Course Schedule II

    Course Schedule

    Clone Graph

    参考资料:

    https://discuss.leetcode.com/topic/30572/share-some-thoughts/2

    https://discuss.leetcode.com/topic/67543/java-o-n-solution-with-explanation-dfs-twice-beat-95

    LeetCode All in One 题目讲解汇总(持续更新中...)

  • 相关阅读:
    ch_5102 Mobile Service
    ch_POJ1201 Intervals
    [CodeVs]谁是赢家
    树上莫队
    [NOI2009]管道区珠
    拉格朗日差值
    Simpson&自适应Simpson
    数论学习笔记
    hibernate FetchType理解
    Hibernate的generator属性之意义
  • 原文地址:https://www.cnblogs.com/grandyang/p/5000291.html
Copyright © 2020-2023  润新知